
--[[ RepBar Functions ]] --

Xparky.RepBar = Xparky:inheritsFrom(Xparky.BaseBar, {
				BarType = "Rep",
				Colours = {
					RepBar = { Red = 1, Green = 0.2, Blue = 1, Alpha = 1 },
					NoRepBar = { Red = 0, Green = 0.3, Blue = 1, Alpha = 1 },
				},
				Events = {"UPDATE_FACTION"},
				BarOrder = { [1] = "RepBar", [2] = "NoRepBar" },
				Faction = 6,

				Rotate = 0,
				BarWidth = 300,
				Sections = {},
		})

local RepBar = Xparky.RepBar

function RepBar:Setup(o)
	o = RepBar:create(o or {})
	o.Sections[1] = Xparky.SparkBar:Setup({Name = "RepBar"..o.Name, Colours = o.Colours.RepBar, Rotate = o.Rotate})
	o.Sections[2] = Xparky.BasicBar:Setup({Name = "NoRepBar"..o.Name, Colours = o.Colours.NoRepBar, Rotate = o.Rotate})
	o:ConstructBar()
	o:Update()
	return o
end

function RepBar:Update()
	local BarWidth
	local Attached = self.Attached and getglobal(self.Attached) or nil
	if not Attached then 
		BarWidth = self.BarWidth
	else
		BarWidth = Attached:GetWidth()
	end
	
	self.Sections[1]:Height(self.Thickness)
	self.Sections[2]:Height(self.Thickness)
	self:Width(BarWidth)
	self:Height(self.Thickness)

	local name, description, standingID, bottomValue, topValue, earnedValue = GetFactionInfo(self.Faction) 
	local Percent = BarWidth/(topValue - bottomValue)
	self.Sections[1]:Width(Percent * (earnedValue - bottomValue))
	self.Sections[2]:Width(Percent * (topValue - earnedValue))
	
	self.Sections[2].Base:SetFrameLevel(self.Sections[1].Base:GetFrameLevel() - 2)
	self.Anchor:SetFrameLevel(self.Sections[2].Base:GetFrameLevel() + 2)

end

